/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumDICOMSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_WidthDescriptor;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_WidthDescriptor;


/**
 * This class represents WidthDescriptor - CID6107
 */
public class WidthDescriptor_CID6107 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;
	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Instantiates a new WidthDescriptor_CID6107 Template 
	 */
	public WidthDescriptor_CID6107()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumWidthDescriptor Object of EnumCM_WidthDescriptor represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_WidthDescriptor enumWidthDescriptor)
	{
		switch(enumWidthDescriptor)
		{
		case ENLARGED: this.strCodeValue = EnumCV_WidthDescriptor.ENLARGED_R_40750.getValue();break;
		case NARROW: this.strCodeValue = EnumCV_WidthDescriptor.NARROW_R_41727.getValue();break;
		case VASOCONSTRICTION: this.strCodeValue = EnumCV_WidthDescriptor.VASOCONSTRICTION_112077.getValue();break;
		case VASODILATION: this.strCodeValue = EnumCV_WidthDescriptor.VASODILATION_112078.getValue();break;
		}
	}
	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumWidthDescriptor Object of EnumCM_WidthDescriptor represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_WidthDescriptor enumWidthDescriptor)
	{
		switch(enumWidthDescriptor)
		{
		case ENLARGED : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.ENLARGED.getSNOMEDCTID(); break;
		case NARROW : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.NARROW.getSNOMEDCTID(); break;
		}
	}
	/**
	 * Sets the value for WidthDescriptor
	 * @param enumWidthDescriptor Object of EnumCM_WidthDescriptor.
	 */
	public void setWidthDescriptor(EnumCM_WidthDescriptor enumWidthDescriptor)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumWidthDescriptor.getValue();
		if(strCodeMeaning.equalsIgnoreCase(EnumCM_WidthDescriptor.VASOCONSTRICTION.getValue())
				|| strCodeMeaning.equalsIgnoreCase(EnumCM_WidthDescriptor.VASODILATION.getValue()))
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
		else
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumWidthDescriptor);
		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumWidthDescriptor);
	}
}
